/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

package org.wso2.esb.jmx.mbean;

import org.wso2.esb.persistence.dataobject.StatisticsDO;

/**
 *
 */

public class SequenceStatisticsView extends AbstractStatisticsView implements SequenceStatisticsViewMBean {
    public SequenceStatisticsView() {
        super();
    }

    public String[] listSequences() {
        String[] names = serviceAdmin.listSequence();
        if (names != null && names.length != 0) {
            return names;
        } else {
            return new String[]{NODATA};
        }
    }

    public int getTotalCount(String sequenceName, String direction) {
        StatisticsDO[] resultSet = serviceAdmin.getSequenceStatistics(sequenceName);
        return getTotalCount(resultSet, direction);
    }

    public int getFaultCount(String sequenceName, String direction) {
        StatisticsDO[] resultSet = serviceAdmin.getSequenceStatistics(sequenceName);
        return getFaultCount(resultSet, direction);
    }

    public double getMaxTime(String sequenceName, String direction) {
        StatisticsDO[] resultSet = serviceAdmin.getSequenceStatistics(sequenceName);
        return getMaxTime(resultSet, direction);
    }

    public double getMinTime(String sequenceName, String direction) {
        StatisticsDO[] resultSet = serviceAdmin.getSequenceStatistics(sequenceName);
        return getMinTime(resultSet, direction);
    }

    public double getAvgTime(String sequenceName, String direction) {
        StatisticsDO[] resultSet = serviceAdmin.getSequenceStatistics(sequenceName);
        return getAvgTime(resultSet, direction);
    }

}
