/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

package org.wso2.esb.jmx.mbean;

import org.apache.axis2.AxisFault;
import org.wso2.esb.ServiceBusException;
import org.wso2.esb.ServiceBusManager;
import org.wso2.esb.services.tos.ServerStatus;

/**
 *
 */

public class ServerStatusView implements ServerStatusViewMBean {

    private final ServerStatus serverStatus;

    public ServerStatusView() {
        this.serverStatus = new ServerStatus();
    }

    public String viewSystemUpTime() {
        update();
        return this.serverStatus.getSystemUpTime();
    }

    public String viewServerStartTime() {
        update();
        return this.serverStatus.getServerStartTime();
    }

    public String viewServerName() {
        update();
        return this.serverStatus.getServerName();
    }

    public String viewFreeMemory() {
        update();
        return this.serverStatus.getFreeMemory();
    }

    public String viewTotalMemory() {
        update();
        return this.serverStatus.getTotalMemory();
    }

    private void update() {
        try {
            this.serverStatus.updateStates(
                    ServiceBusManager.getInstance().getConfigurationContext().getAxisConfiguration());
        } catch (AxisFault axisFault) {
            throw new ServiceBusException("Error initiating ServerStatusView", axisFault);
        }
    }
}
