/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

package org.wso2.esb.jmx.mbean;

import org.wso2.esb.ServiceBusManager;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * JMX Contoller MBean for the ServiceBusManager
 */

public class ServiceBusControl implements ServiceBusControlMBean {

    private static final Log log = LogFactory.getLog(ServiceBusControl.class);
    private ServiceBusManager sbm = ServiceBusManager.getInstance();

    public void start() throws Exception {
        Thread.currentThread().setContextClassLoader(sbm.getClassLoader());
        sbm.start();
    }

    public void stop() throws Exception {
        Thread.currentThread().setContextClassLoader(sbm.getClassLoader());
        sbm.stop();
    }

    public void restart() throws Exception {
        log.info("Re-starting the WSO2 Enterprise Service Bus..");
        Thread.currentThread().setContextClassLoader(sbm.getClassLoader());
        sbm.stop();
        sbm.start();
    }

    public void shutdown() throws Exception {
        Thread.currentThread().setContextClassLoader(sbm.getClassLoader());
        sbm.shutdown();
    }

    public void shutdownGracefully(long secs) throws Exception {
        Thread.currentThread().setContextClassLoader(sbm.getClassLoader());
        sbm.shutdownGracefully(secs * 1000);
    }

    public void startMaintenance() throws Exception {
        Thread.currentThread().setContextClassLoader(sbm.getClassLoader());
        sbm.startMaintenance();
    }

    public void endMaintenance() throws Exception {
        Thread.currentThread().setContextClassLoader(sbm.getClassLoader());
        sbm.endMaintenance();
    }
}
