/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

package org.wso2.esb.jmx.mbean;

/**
 *  Core ESB instance JVM control via JMX
 */
public interface ServiceBusControlMBean {

    /** Start the ESB */
    void start() throws Exception;

    /** Stop the ESB (now!), but keep dormant thread running to start via JMX again */
    void stop() throws Exception;

    /** Stop and start the ESB */
    void restart() throws Exception;

    /** Stops the ESB forever (Stop dormant thread and all JMX support) */
    void shutdown() throws Exception;

    /** Stops the ESB gracefully, waiting for a maximum of millis ms */
    void shutdownGracefully(long millis) throws Exception;

    /** Put instance into maintenence - i.e. stop accepting new messages, but keep processing whats already accepted */
    void startMaintenance() throws Exception;

    /** End maintenence and resume normal operations (i.e. start accepting new messages) */
    void endMaintenance() throws Exception;    
}
