/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

package org.wso2.esb.jmx.mbean;

import org.apache.synapse.SynapseConstants;
import org.wso2.esb.persistence.dataobject.StatisticsDO;

/**
 *
 */

public class SynapseServiceStatisticsView extends AbstractStatisticsView implements SynapseServiceStatisticsViewMBean {

    public SynapseServiceStatisticsView() {
        super();
    }

    public int viewTotalCount(String direction) {
        StatisticsDO[] resultSet = serviceAdmin.getProxyServiceStatistics(
            SynapseConstants.SYNAPSE_SERVICE_NAME);
        return getTotalCount(resultSet, direction);
    }

    public int viewFaultCount(String direction) {
        StatisticsDO[] resultSet = serviceAdmin.getProxyServiceStatistics(
            SynapseConstants.SYNAPSE_SERVICE_NAME);
        return getFaultCount(resultSet, direction);
    }

    public double viewMaxTime(String direction) {
        StatisticsDO[] resultSet = serviceAdmin.getProxyServiceStatistics(
            SynapseConstants.SYNAPSE_SERVICE_NAME);
        return getMaxTime(resultSet, direction);
    }

    public double viewMinTime(String direction) {
        StatisticsDO[] resultSet = serviceAdmin.getProxyServiceStatistics(
            SynapseConstants.SYNAPSE_SERVICE_NAME);
        return getMinTime(resultSet, direction);
    }

    public double viewAvgTime(String direction) {
        StatisticsDO[] resultSet = serviceAdmin.getProxyServiceStatistics(
            SynapseConstants.SYNAPSE_SERVICE_NAME);
        return getAvgTime(resultSet, direction);
    }
}
