/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.esb.config.mediator.xml;

import junit.extensions.TestSetup;
import junit.framework.Test;
import junit.framework.TestSuite;
import org.apache.axiom.om.OMAbstractFactory;
import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMFactory;
import org.apache.axiom.om.OMNamespace;
import org.apache.axiom.om.impl.builder.StAXOMBuilder;
import org.custommonkey.xmlunit.XMLTestCase;
import org.wso2.esb.mediators.transform.SmooksMediator;

import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamReader;
import java.io.StringReader;

/**
 * 
 */
public class SmooksMediatorSerializationTest extends XMLTestCase {

    private static SmooksMediator mediator;
    private static String xml = "<smooks xmlns=\"http://ws.apache.org/ns/synapse\" " +
                                "key=\"smooks-config.xml\" />";

    public void testSerializer() throws Exception {
        
        OMFactory factory = OMAbstractFactory.getOMFactory();
        OMNamespace ns1 = factory.createOMNamespace("test","test");
        OMElement parent = factory.createOMElement("parent",ns1);
        OMElement result = new SmooksMediatorSerializer().serializeMediator(
                parent, mediator);
        assertXMLEqual(xml, result.toString());
    }

    public static Test suite() {
        
        return new TestSetup(new TestSuite(SmooksMediatorSerializationTest.class)) {
            
            protected void setUp() throws Exception {
                XMLStreamReader reader =
                        XMLInputFactory.newInstance().createXMLStreamReader(new StringReader(xml));
                StAXOMBuilder builder = new StAXOMBuilder(reader);
                OMElement omElement = builder.getDocumentElement();
                mediator = (SmooksMediator) (new SmooksMediatorFactory().createMediator(omElement));
            }

            protected void tearDown() throws Exception {

            }
        };
    }
}
