/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

package org.wso2.esb;

import java.net.URI;
import java.io.File;

/*
* ServiceBusConstants use by WSO2 ESB
*/
public final class ServiceBusConstants {

    public static final String MESSAGE_MAP_KEY = "Message_Map_Key";
    public static final String IN_MESSAGE_MAP_KEY = "IN_Message_Map_Key";
    public static final String OUT_MESSAGE_MAP_KEY = "OUT_Message_Map_Key";
    public static final String IN_FAULT_MESSAGE_MAP_KEY = "IN_FAULT_Message_Map_Key";
    public static final String OUT_FAULT_MESSAGE_MAP_KEY = "OUT_FAULT_Message_Map_Key";
    public static final String ADMIN_TRANSPORT = "admin/https";
    public static final String HTTP_TRANSPORT = "http";
    public static final String HTTPS_TRANSPORT = "https";

    public static final String ADMIN_SERVICE_GROUP = "ESBAdmin";
    public static final String ESB_INSTANCE = "WSO2 ESB";
    public static final String ESB_XML_NAMESPACE = "http://www.wso2.org/projects/esb";
    public static final String ESB_WEB_XML_KEY = "ESB_WEB_XML_KEY";
    public static final String ESB_HOME = "esb.home";

    public static final String WELCOME_PAGE = "INDEX_HTML_FILE";
    public static final String GENERATED_PAGES = "wso2esb.generated.pages";

    // ServiceBusConstants for ESB registry
    public static final int LOCAL_HOST_REGISTRY = 100;
    public static final int REMOTE_HOST_REGISTRY = 101;
    public static final int REGISTRY_MODE = LOCAL_HOST_REGISTRY;
    // this will be overwritten if localRegistry parameter is set
    public static final String LOCAL_REGISTRY_ROOT = "registry/";
    public static final String REGISTRY_FILE = "file";
    public static final String REGISTRY_FOLDER = "folder";
    public static final URI folder =
            URI.create("http://wso2.org/projects/esb/registry/types/folder");
    // use if the exact file type is not known
    public static final URI file =
            URI.create("http://wso2.org/projects/esb/registry/types/file");


    public static final String WSO2ESB_HB_CONFIG_KEY = "wso2esb_hb_configuration_key";

    public static final String LOG4J_PROPS = "log4j.properties";
    public static final String SERVER_XML = "server.xml";
    public static final String SERVER_NAME = "serverName";
    public static final String SYNAPSE_XML = "synapse.xml";
    public static final String RESOLVE_ROOT = "resolve.root";
    public static final String AXIS2_XML = "axis2.xml";
    public static final String AXIS2_REPO = "axis2.repo";
    public static final String ESB_SERVER_WEB_XML = "server-web.xml";
    public static final String UI_EXTENSIONS_CONFIG_XML = "conf/ui-extensions-config.xml";
    public static final String HIBERNATE_CFG_XML = "conf/wso2esb.hibernate.cfg.xml";
    public static final String ESB_CONF_DIRECTORY = "webapp" + File.separator + "WEB-INF" + File.separator + "classes" + File.separator + "conf" + File.separator;
    public static final String JMX_AGENT_NAME = "jmx.agent.name";
    public static final String DEFAULT_JMX_AGENT_NAME = "org.wso2.esb";

    public static String REGISTRY = "Registry";
    public static String USERMANAGER_CONFIG = "UsermanagerConfig";
    public static String CONFIGURATION = "configuration";
    public static String DRIVER_CLASS = "driverClass";
    public static String URL = "url";
    public static String USERNAME = "username";
    public static String PASSWORD = "password";
    public static String IMPORT_ROOT = "importRoot";
    public static String TYPE = "type";


    public static class Logging {
        public static String ESB_CONSOLE_APPENDER = "ESB_CONSOLE_APPENDER";
        public static String ESB_LOG_FILE_APPENDER = "ESB_LOG_FILE_APPENDER";
        public static String ESB_MEMORY_APPENDER = "ESB_MEMORY_APPENDER";
    }

    // ServiceBusConstants for DataBase Access
    public static class DBAccess {
        public static final String DERBY_NETWOEK_SERVER_DRIVER
                = "org.apache.derby.jdbc.ClientDriver";
        public static final String STATISTICS_DO = "StatisticsDO";
    }
}
